<script>
import appConfig from '@src/app.config.json'
import Layout from '@layouts/main'
import JobOfferCardList from '@components/job-offer/job-offer-card-list'
import JobOffer from "@src/models/job-offer/JobOffer";
import Loader from "@components/utils/loader";

export default {
  page: {
    title: 'Recrutement',
    meta: [{ name: 'description', content: appConfig.description }],
  },
  components: { Layout, Loader, JobOfferCardList },
  data() {
    return {
      title : 'Recrutement',
      trashJobOffers : null,
      publishedJobOffers : null,
      archivedJobOffers : null,
      trashJobOffersFiltered : null,
      publishedJobOffersFiltered : null,
      archivedJobOffersFiltered : null,
      term : '',
      cardOptions : {
        editBtn : true,
        showBtn : false
      },
      visible_trashed: false,
      visible_published: false,
      visible_archived: false,
    }
  },
  mounted() {
    this.initListJobOffers()
  },
  methods : {
    search() {
      this.trashJobOffersFiltered = this.trashJobOffers.filter( jobOffer => this.in(jobOffer));
      this.publishedJobOffersFiltered = this.publishedJobOffers.filter( jobOffer => this.in(jobOffer))
      this.archivedJobOffersFiltered = this.archivedJobOffers.filter( jobOffer => this.in(jobOffer))
      if( this.term === '' ) {
        this.initListJobOffers()
      }
    },
    in(jobOffer){
      if(
        (jobOffer.name && jobOffer.name.includes( this.term ) === true) ||
        (jobOffer.missions && jobOffer.missions.includes( this.term ) === true) ||
        (jobOffer.required_profile && jobOffer.required_profile.includes( this.term ) === true) ||
        (jobOffer.benefits && jobOffer.benefits.includes( this.term ) === true)){
        return jobOffer;
      }
    },
    async initListJobOffers() {
      this.trashJobOffers = [];
      this.publishedJobOffers = [];
      this.archivedJobOffers = [];
      const jobOffers = await this.$store.dispatch('jobOffer/all')
      jobOffers.forEach(jobOffer => {
        if (jobOffer.status === 1) {
          this.trashJobOffers.push(new JobOffer(jobOffer))
        } else if (jobOffer.status === 2) {
          this.publishedJobOffers.push(new JobOffer(jobOffer))
        } else {
          this.archivedJobOffers.push(new JobOffer(jobOffer))
        }
      });
      this.trashJobOffersFiltered = this.trashJobOffers;
      this.publishedJobOffersFiltered = this.publishedJobOffers;
      this.archivedJobOffersFiltered = this.archivedJobOffers;
    }
  }
}
</script>

<template>
  <Layout :title="title">
    <div id="recruitment-page">
      <div id="recruitment-form-container">
        <form class="form-inline">
          <form @submit.prevent="search">
            <div class="input-group mr-2">
              <input v-model="term" type="text" @keyup="search" class="form-control" placeholder="Filtrez vos annonces">
            </div>
          </form>
          <router-link :to="{ name: 'recruitment_creation' }" class="waves-effect">
            <b-button type="button" variant="primary" class="mr-2">Créer une annonce</b-button>
          </router-link>
        </form>
      </div>
      <div v-if="trashJobOffers && archivedJobOffers && archivedJobOffers">
        <div>
          <h2 :class="visible_trashed ? null : 'collapsed'" :aria-expanded="visible_trashed ? 'true' : 'false'" @click="visible_trashed = !visible_trashed">
            Brouillons ({{trashJobOffersFiltered.length}})
            <span class="float-right" >
            <i :class="{'fa fa-caret-left' : !visible_trashed, 'fa fa-caret-down' : visible_trashed}" aria-hidden="true"></i>
          </span>
          </h2>
          <b-collapse v-model="visible_trashed">
            <job-offer-card-list v-if="trashJobOffersFiltered.length !== 0" :jobOffers="trashJobOffersFiltered" :options="cardOptions"></job-offer-card-list>
            <p v-else class="font-italic text-center text-muted">Aucune offre</p>
          </b-collapse>
        </div>
        <div>
          <h2 :class="visible_published ? null : 'collapsed'" :aria-expanded="visible_published ? 'true' : 'false'" @click="visible_published = !visible_published">
            Publiées ({{publishedJobOffersFiltered.length}})
            <span class="float-right" >
            <i :class="{'fa fa-caret-left' : !visible_published, 'fa fa-caret-down' : visible_published}" aria-hidden="true"></i>
          </span>
          </h2>
          <b-collapse v-model="visible_published">
            <job-offer-card-list v-if="publishedJobOffersFiltered.length !== 0" :jobOffers="publishedJobOffersFiltered" :options="cardOptions"></job-offer-card-list>
            <p v-else class="font-italic text-center text-muted">Aucune offre</p>
          </b-collapse>
        </div>
        <div>
          <h2 :class="visible_archived ? null : 'collapsed'" :aria-expanded="visible_archived ? 'true' : 'false'" @click="visible_archived = !visible_archived">
            Archivés ({{archivedJobOffersFiltered.length}})
            <span class="float-right">
            <i :class="{'fa fa-caret-left' : !visible_archived, 'fa fa-caret-down' : visible_archived}" aria-hidden="true"></i>
          </span>
          </h2>
          <b-collapse v-model="visible_archived">
            <job-offer-card-list v-if="archivedJobOffersFiltered.length !== 0" :jobOffers="archivedJobOffersFiltered" :options="cardOptions"></job-offer-card-list>
            <p v-else class="font-italic text-center text-muted">Aucune offre</p>
          </b-collapse>
        </div>
      </div>
      <loader class="mt-5" v-else></loader>
    </div>
  </Layout>
</template>
